
import time,sys


#global variables:

# n of psl(n|n)
n=0
representation="not set"

# this b is the k in the algebra metric in file pslnn.tex
b=1

class letter(object):
    def __init__(self,name,i,j):
        self.name = name
        self.i = i
        self.j = j


    def __repr__(self):
        return self.name + str(self.i) + str(self.j)


    def isL(self):
        if self.i < n and self.j < n:
            return True
        else:
            return False

    def isR(self):
        if self.i >= n and self.j >= n:
            return True
        else:
            return False

    def isQ(self):
        if self.i >=n and self.j < n:
            return True
        else:
            return False

    def isQbar(self):
        if self.i < n and self.j >= n:
            return True
        else:
            return False


class operator(list):
    def __init__(self,start,matrix):
        self[:] = start
        self.matrix = matrix

    def sortNice(self):
        self.sort(key=lambda goat: goat.order)


    def fermionsLegal(self):
        for item in listAll(self.matrix):
            if item.f==1 and self.count(item)>1:
                    return False

        return True

    def totalCartans(self):
        self.cartans=[0]*(2*n-2)
        for item in self:
            for i in range(0,2*n-2):
                self.cartans[i]+=item.cartans[i]


    def stateLegal(self):
        desiredCasimir = [0]*(2*n-2)
        if not self.cartans==desiredCasimir:
            return False
        if not self.fermionsLegal():
            return False
        return True


    def countFermions(self):
        result = 0
        for item in self:
            result+=item.f

        return result



    def killGhost(self,toKill):
        result=operator(self[:],self.matrix)        
        if toKill.f==1:
            coeff = (-1)**operator(result[:result.index(toKill)],self.matrix).countFermions()
        else:
            coeff = result.count(toKill)
#            if toKill.isQbar():
#                coeff=coeff*b


        result.remove(toKill)
        
        return coeff,result


    def addGhost(self,toAdd):
        result = operator(self[:],self.matrix)
        result.append(toAdd)
        result.sortNice()
        if toAdd.f==1:
            sign = (-1)**operator(result[:result.index(toAdd)],self.matrix).countFermions()
        else:
            sign = 1

        return sign,result


def buildMatrix(name,ghost):

    result = []

    #assemble matrix
    for i in range(0,2*n):
        result.append([])
        for j in range(0,2*n):
            result[i].append(letter(name,i,j))

            #assign fermion indicator
            if ghost:
                if result[i][j].isQ() or result[i][j].isQbar():
                    result[i][j].f=0
                else:
                    result[i][j].f=1
            else:
                if result[i][j].isQ() or result[i][j].isQbar():
                    result[i][j].f=1
                else:
                    result[i][j].f=0

    return result

def commutator(matrix,algebra1,algebra2):
    result = []
    if algebra1.isL() and algebra2.isL():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])


    if algebra1.isR() and algebra2.isR():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])


    if algebra1.isL() and algebra2.isQ():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra1.i==algebra1.j:
            result.append([-1.0/n,algebra2])

    if algebra1.isQ() and algebra2.isL():
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])
        if algebra2.i==algebra2.j:
            result.append([1.0/n,algebra1])



    if algebra1.isL() and algebra2.isQbar():
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])
        if algebra1.i==algebra1.j:
            result.append([1.0/n,algebra2])

    if algebra1.isQbar() and algebra2.isL():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra2.i==algebra2.j:
            result.append([-1.0/n,algebra1])



    if algebra1.isR() and algebra2.isQ():
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])
        if algebra1.i==algebra1.j:
            result.append([1.0/n,algebra2])

    if algebra1.isQ() and algebra2.isR():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra2.i==algebra2.j:
            result.append([-1.0/n,algebra1])




    if algebra1.isR() and algebra2.isQbar():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra1.i==algebra1.j:
            result.append([-1.0/n,algebra2])

    if algebra1.isQbar() and algebra2.isR():
        if algebra2.i==algebra1.j:
            result.append([-1,matrix[algebra1.i][algebra2.j]])
        if algebra2.i==algebra2.j:
            result.append([1.0/n,algebra1])




    if algebra1.isQ() and algebra2.isQbar():
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])
        if algebra2.i==algebra1.j:
            result.append([1,matrix[algebra1.i][algebra2.j]])

    if algebra1.isQbar() and algebra2.isQ():
        if algebra2.i==algebra1.j:
            result.append([1,matrix[algebra1.i][algebra2.j]])
        if algebra1.i==algebra2.j:
            result.append([1,matrix[algebra2.i][algebra1.j]])




    return result




#returns eigenvalues of nL11,...nL(n-1)(n-1),nR11,...nR(n-1)(n-1)
def cartans(matrix,algebra):
    
    result = []

    for p in range(0,n-1):
        dummy = commutator(matrix,matrix[p][p],algebra)
        toAdd=0
        for item in dummy:
            toAdd+=item[0]
        result.append(int(n*toAdd))

    for p in range(n,2*n-1):
        dummy = commutator(matrix,matrix[p][p],algebra)
        toAdd=0
        for item in dummy:
            toAdd+=item[0]
        result.append(int(n*toAdd))



    return result


def dual(matrix,algebra):

    return matrix[algebra.j][algebra.i]




def listAll(matrix):

    result = []

    for i in range(0,2*n):
        for j in range(0,2*n):
            result.append(matrix[i][j])


    return result
                       
def listPSL(matrix):
    result = listAll(matrix)
    result.remove(matrix[n-1][n-1])
    result.remove(matrix[2*n-1][2*n-1])

    return result


def populateMatrixWithCartans(matrix):

    for item in listAll(matrix):
        item.cartans = cartans(matrix,item)

def populateMatrixWithOrder(matrix):

    counter = 1
    for item in listAll(matrix):
        item.order = counter
        counter+=1




def recurGhosts(matrix,ghostNumber,current,listItems,representation,vector,final):
    if current==ghostNumber:
        toAdd = operator(vector,matrix)
        toAdd.totalCartans()

        if toAdd.stateLegal():
            toAdd.sortNice()
            if toAdd not in final:
                final.append(toAdd)
    else:
        for item in listItems:
            newVector = vector[:]
            newVector.append(item)
            recurGhosts(matrix,ghostNumber,current+1,listItems,representation,newVector,final)


def generateStates(matrix,ghostNumber,representation):

    final=[]

    allowedGhosts = listPSL(matrix)

    if representation=="trivial":
        recurGhosts(matrix,ghostNumber,0,allowedGhosts,representation,[],final)
    else:
        print "representation not known"

    return final



def consolidate(listOps):
    coeffs = []
    operators = []
    for item in listOps:
        if item[1] not in operators:
            operators.append(item[1])
            coeffs.append(item[0])
        else:
            index = operators.index(item[1])
            coeffs[index]+=item[0]
            if coeffs[index]==0:
                coeffs.pop(index)
                operators.pop(index)

    result = []
    for i in range(0,len(coeffs)):
        result.append([coeffs[i],operators[i]])

    return result


def generatePairs(M):

    all = listPSL(M)

    result = []

    while(all!=[]):
        top = all[0]
        all.pop(0)
        for item in all:
            result.append([top,item])

    return result


def generateAllPSLCommutators(matrix):

    result = []


    pairs = generatePairs(matrix)

    for pair in pairs:

        initial = commutator(matrix,pair[0],pair[1])


        comm = []
        for part in initial:
            if part[1]==matrix[n-1][n-1]:
                for index in range(0,n-1):
                    comm.append([-part[0],matrix[index][index]])
            elif part[1]==matrix[2*n-1][2*n-1]:
                for index in range(n,2*n-1):
                    comm.append([-part[0],matrix[index][index]])
            else:
                comm.append(part)





        cleanCoeffs=[]
        clean=[]
        for part in comm:
            #make everything integer
            part[0]=int(n*part[0])
            if part[1] not in clean:
                cleanCoeffs.append(part[0])
                clean.append(part[1])
            else:
                index = clean.index(part[1])
                dummy = cleanCoeffs[index]+part[0]
                if dummy == 0:
                    clean.pop(index)
                    cleanCoeffs.pop(index)
                else:
                    cleanCoeffs[index]=dummy
            
        cleanCombined = []
        for i in range(0,len(clean)):
            result.append([pair[0],pair[1],clean[i],cleanCoeffs[i]])


    return result


def cubic(cgh1,cgh2,bgh):

    result = 0

    if cgh1.isL():
        if cgh2.isL():
            if cgh1.i==bgh.j and cgh2.i==cgh1.j and bgh.i==cgh2.j:
                result+= -1
            if cgh1.i==(n-1) and cgh2.j==(n-1) and cgh2.i==cgh1.j and bgh.i==bgh.j:
                result+= 1


        elif cgh2.isQbar():
            if cgh1.i==bgh.j and cgh2.i==cgh1.j and bgh.i==cgh2.j:
                result+= -1
            if cgh1.i==cgh1.j and cgh2.i==bgh.j and bgh.i==cgh2.j:
                result+= 1.0/n
        elif cgh2.isQ():
            if cgh1.i==cgh2.j and cgh2.i==bgh.j and bgh.i==cgh1.j:
                result+= b
            if cgh1.i==cgh1.j and cgh2.i==bgh.j and bgh.i==cgh2.j:
                result+= -b/float(n)



    if cgh1.isR():
        if cgh2.isR():
            if cgh1.i==bgh.j and cgh2.i==cgh1.j and bgh.i==cgh2.j:
                result+= -1
            if cgh1.i==(2*n-1) and cgh2.j==(2*n-1) and cgh2.i==cgh1.j and bgh.i==bgh.j:
                result+= 1

        elif cgh2.isQbar():
            if cgh1.i==cgh2.j and cgh2.i==bgh.j and bgh.i==cgh1.j:
                result+= 1
            if cgh1.i==cgh1.j and cgh2.i==bgh.j and bgh.i==cgh2.j:
                result+= -1.0/n
        elif cgh2.isQ():
            if cgh1.i==bgh.j and cgh2.i==cgh1.j and bgh.i==cgh2.j:
                result+= -b
            if cgh1.i==cgh1.j and cgh2.i==bgh.j and bgh.i==cgh2.j:
                result+= +b/float(n)


    if cgh1.isQbar() and cgh2.isQ():
        if cgh1.i==bgh.j and cgh2.i==cgh1.j and bgh.i==cgh2.j:
            result+=-b
        if cgh1.i==(n-1) and cgh2.j==(n-1) and cgh2.i==cgh1.j and bgh.i==bgh.j:
            result+=b

        if cgh1.i==cgh2.j and cgh2.i==bgh.j and bgh.i==cgh1.j:
            result+=-b

        if cgh2.i==(2*n-1) and cgh1.j==(2*n-1) and cgh1.i==cgh2.j and bgh.i==bgh.j:
            result+=b

    if int(result*n)-result*n!=0:
        print "integer error!"
        sys.exit(0)

    return int(result*n)


def Qcohomology(matrix,op):

    result = []

    #for c1 c2 b

    for bgh in listPSL(matrix):
        for cgh1 in listPSL(matrix):
            for cgh2 in listPSL(matrix):
                if dual(matrix,bgh) in op:
                    cubicTerm = cubic(cgh1,cgh2,bgh)
                    if cubicTerm!=0:
                        coeff1,new1 = op.killGhost(dual(matrix,bgh))
                        coeff2,new2 = new1.addGhost(cgh2)
                        coeff3,new3 = new2.addGhost(cgh1)
                        if new3.fermionsLegal():
                            result.append([cubicTerm*coeff1*coeff2*coeff3,new3])

    return result





class Qresult(list):
    def __init__(self,start):
        self[:] = start
        self.key = []
        self.states = []

    def addColumn(self):
        for row in self:
            row+=[0]
        return 0
    
    def addRow(self):
        self.append([0]*len(self.key))



# returns matrix of Q
def Qmatrix(matrix,ghostNum,representation):


    result =  Qresult([])


    states = generateStates(matrix,ghostNum,representation)

    for item in states:

        result.states.append(item)


        image = Qcohomology(matrix,item)

        for element in image:

            element[1].totalCartans()
            if not element[1].stateLegal():
                print "state", element[1], "in image of",item,"not legal"
                return 0


            if element[1] not in result.key:
                result.key.append(element[1])
                result.addColumn()

        rowToAdd = [0]*len(result.key)

        for element in image:
            position = result.key.index(element[1])
            rowToAdd[position] += element[0]
        

        result.append(rowToAdd)
        
    for i in range(0,len(result)):
        for j in range(0,len(result.key)):
            if result[i][j]-int(result[i][j])!=0:
                print "program won't work because non-integer entries in result",result[i][j],int(result[i][j])
            result[i][j] = int(result[i][j])

    if len(result)!=len(result.states):
        print "error! length of states is different from length of result"
    if len(result)>1:
        if len(result[0])!=len(result.key):
            print "error! length of row not equal to key"


    return result



def initializeEverything(nameMatrix):
    matrix = buildMatrix(nameMatrix,True)

    populateMatrixWithCartans(matrix)

    populateMatrixWithOrder(matrix)


    for i in range(0,2*n):
        for j in range(0,2*n):
            print matrix[i][j].f,
        print ""
    return matrix



if __name__=="__main__":

    if len(sys.argv)!=3:
        print "error: requires n and a ghost number argument"
        print "for example:"
        print "python pslnn.py 3 4"
        sys.exit(0)

    n = int(sys.argv[1])
    ghostNumber = int(sys.argv[2])
    representation="trivial"

    M = initializeEverything("M")

    A = Qmatrix(M,ghostNumber,representation)

    print "that is a total of",len(A.states),"states"
#    print "maximum size of image is",len(A.key)


    outputFile = open("matrix.sage", 'w')
    outputFile.write("total = " + str(len(A.states)) + "\n\n")
    outputFile.write("A = matrix(" + str(A)+ ")\n\n")
    outputFile.close()


